<?php

include "_config/display.php";
SetHead("Sudoku Solver",true);
?>
<script>
	var grille=new Array();

	for(i=0;i<9;i++)
	{
		grille[i]=new Array();

		for(j=0;j<9;j++)
		{
			grille[i][j]=new Array();

			for(k=1;k<10;k++)
			{
				grille[i][j][k]=1;
			}
		}
	}
	//////////////////////////////////////////////

	function CheckGrille()
	{

		for(i=0;i<9;i++)
		{

			for(j=0;j<9;j++)
			{
				o=document.getElementById('case_'+i+'_'+j);
				value=parseInt(o.options[o.selectedIndex].value);

				if(value && is_array(grille[i][j]))
				{
					grille[i][j]=value;
					UnsetRow(i,value);
					UnsetCol(j,value);
					UnsetSquare(i,j,value);
				}
			}
		}
	}

	function UnsetRow(iRow, value)
	{

		for(jC=0;jC<9;jC++)
		{

			if(is_array(grille[iRow][jC]))
			{
				grille[iRow][jC][value]=0;
				TestValues(iRow, jC);
			}
		}
	}

	function UnsetSquare(iRow, jCol, value)
	{
		cRow=Math.floor(iRow/3);
		cCol=Math.floor(jCol/3);

		for(iR=0;iR<9;iR++)
		{

			for(jC=0;jC<9;jC++)
			{

				if(Math.floor(iR/3)==cRow && Math.floor(jC/3)==cCol)
				{

					if(is_array(grille[iR][jC]))
					{
						grille[iR][jC][value]=0;
						TestValues(iR, jC);
					}
				}
			}
		}
	}

	function UnsetCol(jCol, value)
	{

		for(iR=0;iR<9;iR++)
		{

			if(is_array(grille[iR][jCol]))
			{
				grille[iR][jCol][value]=0;
				TestValues(iR, jCol);
			}
		}
	}

	function TestValues(i,j)
	{
		o=document.getElementById('case_'+i+'_'+j);

		if(!is_array(grille[i][j]))
		{
			val=grille[i][j];
			o.innerHTML='<option value="'+val+'">'+val+'</option>'
			return;
		}
		nb=0;
		val='';
		retour='<option value=""></option>';

		for(k=1;k<10;k++)
		{

			if(grille[i][j][k]==1)
			{
				nb++;
				val=k;
				retour+='<option value="'+k+'">'+k+'</option>';
			}
		}
		//MAJ liste		
		temp=o.options[o.selectedIndex].value;
		o.innerHTML=retour;
		o.value=temp;

		if(nb==1)
		{
			grille[i][j]=val;
			o.innerHTML='<option value="'+val+'">'+val+'</option>'
		}
	}

	function is_array(variable)
	{
		return (variable.length!=null && variable.length>1);
	}
</script>
<table width="350">
<?

for($i=0;$i<9;$i++)
{
	echo '<tr>';

	for($j=0;$j<9;$j++)
	{
		?>
		<td>
			<select id="case_<?php echo $i ?>_<?php echo $j ?>" onchange="CheckGrille();return false;">
			<option value=""></option>
			<?php

			for($l=1;$l<10;$l++)
			{
			?>
				<option value="<?php echo $l ?>"><?php echo $l ?></option>
			<?php
			}
			?>
			</select>
		</td>
		<?php
	}
	echo '<tr>';
}
?>
</table>
<?php
SetFoot();
?>
